/* Handle PNM-files  Dez98 JS
 * 0,0 = left up
 * PAM-formats
 * PAM any  P7  
 * PNM-formats
 * PGM gray ASCII=P2 RAW=P5 dx dy col gray
 * PPM RGB  ASCII=P3 RAW=P6 dx dy col RGB
 * PBM B/W  ASCII=P1 RAW=P4 dx dy     bitmap
 */

#ifndef GOCR_PNM_MEM_H
#define GOCR_PNM_MEM_H 1

typedef struct
{
	int		x0;
	int		x1;
	int		y0;
	int		y1;
	char	c;
	int		line;
	int		Tops;
	float	Slope;
} CharCoord;

// This will allow me to include this file from both a .c file or a .cpp file.
#ifndef __cplusplus
void RunOCR(unsigned char* Bitmap,int nx, int ny, char (*Line)[128], int *NumLines,
			CharCoord* CharactersXY, int* NumChars, int FixItalics, int Space); 
#else

extern "C" int OCRVerbose;
extern "C" int DoJustItalics;

extern "C" void RunOCR(unsigned char* Bitmap,int nx, int ny, char (*Line)[128], int *NumLines,
			CharCoord* CharactersXY, int* NumChars, int FixItalics, int Space);
#endif
#endif
